// This is Free Software licensed under the Apache License, Version 2.0 (the "License").
//
// Copyright 2020 by the contributors.
// See CONTRIBUTORS for details.
//
// SPDX-License-Identifier: Apache-2.0
// License-Filename: LICENSES/apache-2.0.txt
//
// Author(s):
//  * Sascha L. Teichmann (sascha.teichmann@intevation.de)

// +build ignore

package main

import (
	"bufio"
	"flag"
	"fmt"
	"io"
	"log"
	"os"
	"path/filepath"
	"sort"
	"strings"
)

func check(err error) {
	if err != nil {
		log.Fatalf("error: %v\n", err)
	}
}

const (
	header = `// This is Free Software licensed under the Apache License, Version 2.0 (the "License").
//
// Copyright 2020 by the contributors.
// See CONTRIBUTORS for details.
//
// SPDX-License-Identifier: Apache-2.0
// License-Filename: LICENSES/apache-2.0.txt
//
// Author(s):
//  * Sascha L. Teichmann (sascha.teichmann@intevation.de)
//
//  Code generated by go generate; DO NOT EDIT.

package main

var embeddedTemplates = [][]byte {
`
)

func hexDump(indent string, out *bufio.Writer, in io.ByteReader) error {
	count := 0
	for {
		b, err := in.ReadByte()
		if err == io.EOF {
			break
		}
		if err != nil {
			return err
		}
		if count > 0 {
			out.WriteByte(' ')
		} else {
			out.WriteString(indent)
		}
		fmt.Fprintf(out, "0x%02x,", b)
		if count == 11 {
			fmt.Fprintln(out)
			count = 0
		} else {
			count++
		}
	}
	if count != 0 {
		fmt.Fprintln(out)
	}
	return nil
}

func main() {
	dir := flag.String("d", "templates", "dir to scan for templates")
	dst := flag.String("o", "embedded_templates.go", "Go file with embedded templates")
	flag.Parse()

	files, err := filepath.Glob(*dir + "/*.tmpl")
	check(err)

	sort.Strings(files)

	f, err := os.Create(*dst)
	check(err)
	defer f.Close()

	var names []string

	out := bufio.NewWriter(f)
	fmt.Fprintf(out, header)
	for _, f := range files {
		base := filepath.Base(f)

		name := strings.TrimLeft(base, "0123456789")
		name = name[:len(name)-len(filepath.Ext(base))]
		names = append(names, name)

		fmt.Fprintln(out, "\t{")
		check(func() error {
			in, err := os.Open(f)
			check(err)
			defer in.Close()
			return hexDump("\t\t", out, bufio.NewReader(in))
		}())
		fmt.Fprintln(out, "\t},")
	}
	fmt.Fprintln(out, "}\n\nvar templateNames = []string {")
	for _, name := range names {
		fmt.Fprintf(out, "\t\"%s\",\n", name)
	}
	fmt.Fprintln(out, "}")

	check(out.Flush())
}
